package Sledge::Plugin::Validator::email_loose;
use strict;
use vars qw($VERSION);
$VERSION = '0.03';

use Email::Valid::Loose;

sub load {
	my $self = shift;
	$self->set_function(
		EMAIL_LOOSE    => \&is_EMAIL_LOOSE,
		EMAIL_LOOSE_MX => \&is_EMAIL_LOOSE_MX,
	);
}

sub is_EMAIL_LOOSE {
	return (Email::Valid::Loose->address($_[0]))? 1 : 0;
}

sub is_EMAIL_LOOSE_MX {
	return (Email::Valid::Loose->address(-address => $_[0], -mxcheck=>1))? 1 : 0;
}
1;

=head1 NAME

Sledge::Plugin::Validator::email_loose - ᡼륢ɥ쥹ΥåԤޤ

=head1 SYNOPSIS

  $self->valid->check(
      email => [qw(EMAIL_LOOSE EMAIL_LOOSE_MX)]
  );

=head1 DESCRIPTION

᡼륢ɥ쥹RFCŪDNSMX쥳ɤϿƤ뤫
åǤޤ
ܤηäΥɥ쥹뤹褦 @  . Ĥ褦
ɥ쥹ϵĤޤ

EMAIL_LOOSE_MXѤ뤳ȤǤޤ
EMAIL_LOOSEʬεưȤˤʤΤǤС

  $self->valid->load_function('email_loose');
  $self->valid->check(
      email => [qw(EMAIL_LOOSE_MX)]
  );

ͤˤɬפޤ

=head1 CHECK FUNCTION

=over 4

=item EMAIL_LOOSE

᡼륢ɥ쥹RFCŪȡ
 @  . ϵĤޤ

=item EMAIL_LOOSE_MX

ɥᥤ󤬡MX쥳ɤꤵƤ뤳ȡ
 @  . ϵĤޤ

ΥåϡɸǤɤ߹ޤޤ
check᥽åɤǡEMAIL_LOOSE ꤷƤ
load_function('email_loose')  åɤ߹Ǥ

=back

=head1 AUTHOR

KIMURA, takefumi E<lt>takefumi@takefumi.comE<gt>

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself.

=head1 SEE ALSO

L<Sledge::Plugin::Validator>,
L<Email::Valid::Loose>

=cut

