package Sledge::Plugin::Validator::email_strict;
use strict;
use vars qw($VERSION);
$VERSION = '0.02';

use Email::Valid;

sub load {
	my $self = shift;
	$self->set_function(
		EMAIL_STRICT    => \&is_EMAIL_STRICT,
		EMAIL_STRICT_MX => \&is_EMAIL_STRICT_MX,
	);
}

sub is_EMAIL_STRICT {
	return (Email::Valid->address(-address => $_[0]))? 1 : 0;
}

sub is_EMAIL_STRICT_MX {
	return (Email::Valid->address(-address => $_[0], -mxcheck=>1))? 1 : 0;
}

1;

=head1 NAME

Sledge::Plugin::Validator::email - ᡼륢ɥ쥹ΥåԤޤ

=head1 SYNOPSIS

  $self->valid->check(
      email => [qw(EMAIL EMAIL_MX)]
  );

=head1 DESCRIPTION

᡼륢ɥ쥹RFCŪDNSMX쥳ɤϿƤ뤫
åǤޤ


EMAIL_STRICT_MX Ѥ뤳ȤǤޤ
EMAIL_STRICTʬεưȤˤʤΤǤС

  $self->valid->load_function('email');
  $self->valid->check(
      email => [qw(EMAIL_MX)]
  );

ͤˤɬפޤ

=head1 CHECK FUNCTION

=over 4

=item EMAIL_STRICT

᡼륢ɥ쥹RFCŪȡ

=item EMAIL_STRICT_MX

ɥᥤ󤬡MX쥳ɤꤵƤ뤳ȡ

ΥåϡɸǤɤ߹ޤޤ
check᥽åɤǡEMAIL ꤷƤ
load_function('email')  åɤ߹Ǥ

=back

=head1 AUTHOR

KIMURA, takefumi E<lt>takefumi@takefumi.comE<gt>

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself.

=head1 SEE ALSO

L<Sledge::Plugin::Validator>,
L<Email::Valid>

=cut

